#include "collision.h"
#include <iostream>
#include <math.h>

#define PI 3.14159265

using namespace std;

int arecollidingbb(_object *object1, _object *object2)
{
	int top1 = object1->movement.position.y + object1->size.y;
	int top2 = object2->movement.position.y + object2->size.y;
	int bottom1 = object1->movement.position.y - object1->size.y;
	int bottom2 = object2->movement.position.y - object2->size.y;
	int left1 = object1->movement.position.x - object1->size.x;
	int left2 = object2->movement.position.x - object2->size.x;
	int right1 = object1->movement.position.x + object1->size.x;
	int right2 = object2->movement.position.x + object2->size.x;
	int colliding = 0;

	//if((left1 < right2 && right1 > left2) && (top1 > bottom2 && bottom1 < top2))//bounding box
	if((object1->movement.position.x - object2->movement.position.x)*(object1->movement.position.x - object2->movement.position.x) + (object1->movement.position.y - object2->movement.position.y)*(object1->movement.position.y - object2->movement.position.y) < (object1->size.x+object2->size.x)*(object1->size.x+object2->size.x))//radial collision
	{
		colliding = 1;
	}
	
	
	if(colliding)
	{
		if(object2->collected == 1)//is collectable
		{
			object2->collected = 2;//destroy
			cout<<"collected"<<endl;
			colliding = 2;
		}
		if(object2->collidable > 0)// && object1->movement.type==0)//is collidable, i.e. "obstacle"
		{
			object1->movement.position.x = object1->movement.position.prevx;
			object1->movement.position.y = object1->movement.position.prevy;
			if(object1->movement.position.y > object2->movement.position.y)
				object1->movement.jumping = 0;
			else
				object1->movement.jumping = 2;
			//bounce
			if(object1->movement.type == 3)
			{
				//fake surface normal i.e. vector between
				int diffx = object2->movement.position.x - object1->movement.position.x;
				int diffy = object2->movement.position.y - object1->movement.position.y;

				float anglei = object1->movement.direction - atan(diffy/diffx);
			
				object1->movement.direction -= PI;
				object1->movement.direction -= 2*anglei;

			}
		}
	}
	
	return colliding;

}
