#include "game.h"
#include "timer.h"
#include "text.h"

#include <math.h>
#include <iostream>
#include <GL/glut.h>

using namespace std;

#define PI 3.14159265

void _movement::move(float dt)
{
	double timestep = dt;
	
	position.prevx = position.x;
	position.prevy = position.y;
	
	if(type == 0)//4 directional
	{
		if(key[0])//up
		{
			direction = PI/2;
			if(speed < maxspeed) speed += accelerationy*timestep*1000;
			else speed = maxspeed;
			position.y += speed*timestep;
		}
		if(key[1])//right
		{	
			direction = 0;
			if(speed < maxspeed) speed += accelerationx*timestep*1000;
			else speed = maxspeed;
			position.x += speed*timestep;
		}
		if(key[2])//down
		{	
			direction = -PI/2;
			if(speed < maxspeed) speed += accelerationy*timestep*1000;
			else speed = maxspeed;
			position.y -= speed*timestep;
		}
		if(key[3])//left
		{	
			direction = PI;
			if(speed < maxspeed) speed += accelerationx*timestep*1000;
			else speed = maxspeed;
			position.x -= speed*timestep;
		}
	}

	if(type == 1)//car
	{	
		if(key[0])//up
		{
			if(speed < maxspeed) speed += accelerationy*timestep*1000;
			else speed = maxspeed;
			position.y += speed*timestep*sin(direction);
			position.x += speed*timestep*cos(direction);
		}
		
		if(key[1])//right
			direction -= (5*timestep);

		if(key[2])//down
		{
			if(speed < maxspeed) speed += accelerationy*timestep*1000;
			else speed = maxspeed;
			position.y -= speed*timestep*sin(direction);
			position.x -= speed*timestep*cos(direction);
		}
		
		if(key[3])//left
			direction += (5*timestep);
	}

	if(type == 2)//platform
	{	
		position.y -= timestep*gravity;
		
		if(key[0])//up
		{
			if(!jumping)
			{
				jumping = 1;
			}
		}
		
		if(key[1])//right
		{
			direction = 0;
			if(speed < maxspeed) speed += accelerationx*timestep*1000;
			else speed = maxspeed;
			position.x += speed*timestep;
		}

		if(key[2])//down
		{
		//	speed = maxspeed;
		//	position.y -= speed*timestep*sin(direction);
		//	position.x -= speed*timestep*cos(direction);
		}
		
		if(key[3])//left
		{
			direction = PI;
			if(speed < maxspeed) speed += accelerationy*timestep*1000;
			else speed = maxspeed;
			position.x -= speed*timestep;
		}

		//jumping
		if(jumping == 1)
		{
			jumpheight += timestep*gravity;
			position.y += timestep*gravity*2;
		}
		if(jumpheight >= maxjumpheight) jumping = 2;
		if(jumping == 2) jumpheight -= timestep*gravity;
		if(jumpheight <= 0) jumping = 0;
		
	}
	if(type == 3)//bouncing ball
	{	
		if(speed < maxspeed) speed += accelerationy*timestep*1000;
		else speed = maxspeed;
		position.y += speed*timestep*sin(direction);
		position.x += speed*timestep*cos(direction);
	}
		//keep in frame
		if(position.y > 240)
		{
			position.y = 240;
			//direction += direction;
		}
		if(position.y < 0)
		{
			position.y = 0;
			//direction += direction;
		}
		if(position.x >320)
		{
			position.x = 320;
			//direction += direction;
		}
		if(position.x < 0)
		{
			position.x = 0;
			//direction += direction;
		}


}

void _score::print(void)
{
	int i, n, x, temp;

	x=1;
	temp = score;

	for(i=0;i<=8;i++)
	{
		n=temp%10;
		glTranslatef(8-i, 0, 0);
		text.print(n);
		glTranslatef(-(8-i), 0, 0);
		//x*=10;
		temp /= 10;
	//	temp -= n;
	}
//	x *= 10;
//	i = score%100;
//	glTranslatef(7, 0, 0);
//	text.print(i);

}
