#ifndef _game_h_
#define _game_h_

#include "text.h"

class _position{

 public:
	float x, y;
	float prevx, prevy;
};

class _size{

 public:
	int x, y;
};

class _colour{

public:
	double r, g, b;

};

class _movement{

 public:

	_position position;

	int type;
	double speed;
	double maxspeed;
	double accelerationx;
	double accelerationy;
	double direction;
	int key[5];
	int maxjumpheight;
	int jumpheight;
	int jumping;
	double gravity;

	void move(float dt);
	//void keydown(int key);
	//void keyup(int key);

};

class _object{

 public:

 	int collected, collidable;
	_size size;
	_movement movement;
	_colour colour;
	int texture;

};


class _level{

 public:

	_movement movement;

};

class _backdrop{

 public:

	_object object;

};

class _character{

 public:

	_object object;

};

class _goal{

public:

	_object object;

};

class _score{

public:

	int score;
	_text text;
	_position position;

	void print(void);

};

#endif
