#include <iostream>
#include <GL/glut.h>
#include <math.h>
#include <time.h>

#include "game.h"
#include "collision.h"
#include "timer.h"
#include "text.h"
#include "textures.h"

#define PI 3.14159265

using namespace std;

//keyboard functions---------------------------------------------------------------------------------------------
void keyboard(unsigned char key, int x1, int y1);
void skeydown(int key, int x1, int y1);
void skeyup(int key, int x1, int y1);

_character character;
_backdrop *backdrop;
_goal *goal;
int numbackdrops;
int numgoals;
int difficulty=0;
double timer, maxtime = 10;
_score score;
_texture texture;
int z=0;

void init(void)
{
	int i;
	GLfloat position[] = {0.0, 5.0, 20.0, 0.0};//light position
	GLfloat local_view[] = {0.0};//light model
	glLightfv(GL_LIGHT0, GL_POSITION, position);
	glLightModelfv(GL_LIGHT_MODEL_LOCAL_VIEWER, local_view);

	glClearColor((float)(rand()%100)/100,(float)(rand()%100)/100,(float)(rand()%100)/100,1.0);
	glFrontFace(GL_CW);
	glEnable(GL_LIGHTING);
	glEnable(GL_LIGHT0);
	glEnable(GL_AUTO_NORMAL);
	glEnable(GL_NORMALIZE);
	glEnable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	
	glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
//	glBlendFunc(GL_SRC_ALPHA, GL_SRC_ALPHA);
	
	glutSetKeyRepeat(0);//disable key repeats

	srand(time(NULL));
	
	score.position.x = 2;
	score.position.y = 220;
	score.text.initialise();

	if(z==0)
	{
		texture.initialise();
		z++;
	}
	//glDisable(GL_TEXTURE_2D);

	numbackdrops = (rand()%5) + 1;
	numgoals = (rand()%10) + 1;
	timer = maxtime;

	character.object.size.x = (rand()%24)+12;
	character.object.size.y = character.object.size.x;
	character.object.colour.r = 0;
	character.object.colour.g = 0;
	character.object.colour.b = 1;
	character.object.movement.type = rand()%3;
	character.object.movement.maxspeed = 300;
	character.object.movement.speed = 0;
	character.object.movement.gravity = 200;
	character.object.movement.maxjumpheight = 100;
	character.object.movement.accelerationx = 2;
	character.object.movement.accelerationy = 2;
	character.object.movement.jumpheight = 0;
	character.object.movement.jumping = 0;
	character.object.movement.direction = (rand()%360);///180*PI;
	character.object.movement.position.x = rand()%320;
	character.object.movement.position.y = rand()%240;
	character.object.texture = rand()%19;

	backdrop = new _backdrop[numbackdrops];
	for(i=0; i<numbackdrops; i++)
	{
	backdrop[i].object.movement.position.x = rand()%320;
	backdrop[i].object.movement.position.y = rand()%240;
	backdrop[i].object.size.x = (rand()%24)+12;
	backdrop[i].object.size.y = backdrop[i].object.size.x;
	backdrop[i].object.colour.r = 1;
	backdrop[i].object.colour.g = 0;
	backdrop[i].object.colour.b = 0;
	backdrop[i].object.collected = 0;
	backdrop[i].object.collidable = 1;
	backdrop[i].object.texture = rand()%19;
	}
	
	goal = new _goal[numgoals];
	for(i=0; i<numgoals; i++)
	{
	goal[i].object.movement.position.x = rand()%320;
	goal[i].object.movement.position.y = rand()%240;
	goal[i].object.size.x = (rand()%24)+12;
	goal[i].object.size.y = goal[i].object.size.x;
	goal[i].object.colour.r = 0;
	goal[i].object.colour.g = 1;
	goal[i].object.colour.b = 0;
	goal[i].object.collected = 1;
	goal[i].object.collidable = 0;
	goal[i].object.texture = rand()%19;
		for(int j=0; j<numgoals; j++)
			if(i!=j)
				if(arecollidingbb(&goal[i].object, &goal[j].object))
				{
					goal[i].object.movement.position.x = rand()%320;
					goal[i].object.movement.position.y = rand()%240;
				}
	}
	
	int colliding = 1;
	while(colliding)
	{
		colliding = 0;
		for(int i=0; i<numbackdrops; i++)
			if(arecollidingbb(&character.object, &backdrop[i].object))
				colliding = 1;
		if(colliding == 1)
		{
			character.object.movement.position.x = rand()%320;
			character.object.movement.position.y = rand()%240;
		}
	}
	
	
	
}

void update(void)
{
	int i=0, countgoals = 0;

	float frametime = updatetime();
	
	character.object.movement.move(frametime);
	
	for(i=0;i<numbackdrops; i++)
		arecollidingbb(&character.object, &backdrop[i].object);
	for(i=0;i<numgoals; i++)
	{
		if(arecollidingbb(&character.object, &goal[i].object) == 2)
		; 	//score.score++;
		if(goal[i].object.collected == 1)
		{
			countgoals++;
		}
		
	}


	if(!countgoals)
	{
		score.score++;
		cout<<"completed"<<endl;
		//maxtime -= 0.2;
		init();
	}
	timer -= frametime;
	//cout<<"time: "<<timer<<endl;
	if(timer<=0) init();
	glutPostRedisplay();
}

//display(draw stuff)---------------------------------------------------------------------------------------------
void display(void)
{
	int i=0, z=0;
//set up light
glEnable(GL_LIGHTING);
	GLfloat light_ambient[] = {0.2, 0.2, 0.2, 0.0};
	GLfloat light_diffuse[] = {1.0, 0.0, 0.0, 1.0};
	GLfloat light_specular[] = {0, 0, 0, 1.0};
	glLightfv(GL_LIGHT0, GL_AMBIENT, light_ambient);
//	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
	glLightfv(GL_LIGHT0, GL_SPECULAR, light_specular);

	glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0, glutGet(GLUT_WINDOW_WIDTH), 0, glutGet(GLUT_WINDOW_HEIGHT), -1000, 1000 );
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

//draw stuff-------------------------------------------------------------------------------------------------------
	glViewport(0, 0, glutGet(GLUT_WINDOW_WIDTH), glutGet(GLUT_WINDOW_HEIGHT));
	gluLookAt(0,0,1000,0,0,0,0,1,0);

		


	z=0;
	
	for(i=0; i<numgoals; i++)
	{
		if(goal[i].object.collected == 1)
		{
			glPushMatrix();
				light_diffuse[0] = goal[i].object.colour.r;
				light_diffuse[1] = goal[i].object.colour.g;
				light_diffuse[2] = goal[i].object.colour.b;
				glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
				glTranslatef(goal[i].object.movement.position.x-goal[i].object.size.x, goal[i].object.movement.position.y-goal[i].object.size.y, z++);
				glScalef(goal[i].object.size.x*2,goal[i].object.size.y*2,0);
				texture.print(goal[0].object.texture);
			glPopMatrix();
		}
	}

		for(i=0; i<numbackdrops; i++)
	{
		glPushMatrix();
			light_diffuse[0] = backdrop[i].object.colour.r;
			light_diffuse[1] = backdrop[i].object.colour.g;
			light_diffuse[2] = backdrop[i].object.colour.b;
			glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
			glTranslatef(backdrop[i].object.movement.position.x-backdrop[i].object.size.x, backdrop[i].object.movement.position.y-backdrop[i].object.size.y, z++);
			glScalef(backdrop[i].object.size.x*2,backdrop[i].object.size.y*2,0);
			texture.print(backdrop[0].object.texture);
		glPopMatrix();
	}
	
	glPushMatrix();
		light_diffuse[0] = character.object.colour.r;
		light_diffuse[1] = character.object.colour.g;
		light_diffuse[2] = character.object.colour.b;
		glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
		glTranslatef(character.object.movement.position.x, character.object.movement.position.y, z++);
		glRotatef(character.object.movement.direction*180/PI, 0, 0, 1);
		glTranslatef(-character.object.size.x, -character.object.size.y, 0);
	//	glRotatef(90, 1, 0, 0);
		
		glScalef(character.object.size.x*2,character.object.size.y*2,0);
		texture.print(character.object.texture);
	glPopMatrix();
			
//	light_diffuse[0] = 1;
//	light_diffuse[1] = 1;
//	light_diffuse[2] = 1;
//	light_diffuse[3] = 1;
//	glLightfv(GL_LIGHT0, GL_DIFFUSE, light_diffuse);
	glDisable(GL_LIGHTING);
	glBegin(GL_QUADS);
		glVertex3f(4.0, 8.0, 999);
		glVertex3f(4.0, 16.0, 999);
		glVertex3f(2+312.0*(double)(timer/maxtime), 16.0, 999);
		glVertex3f(2+312.0*(double)(timer/maxtime), 8.0, 999);
	glEnd();
	glPushMatrix();
		glTranslatef(score.position.x, score.position.y, 999);
		glScalef(16,16,16);
		score.print();
	glPopMatrix();

	glutSwapBuffers();

}

//special key function-----------------------------------------------------------------------------------------------------------------
void skeydown(int key, int x1, int y1)
{
	switch (key) {

		case GLUT_KEY_UP:
			character.object.movement.key[0] = 1;
			break;		
		case GLUT_KEY_RIGHT:
		    	character.object.movement.key[1] = 1;
			break;
		case GLUT_KEY_DOWN:
			character.object.movement.key[2] = 1;
			break;
		case GLUT_KEY_LEFT:
	    		character.object.movement.key[3] = 1;
			break;
		case GLUT_KEY_INSERT:
			init();
			break;
		default:
			break;
	}
	
	
}

//special key up function---------------------------------------------------------------------------------------------------------------
void skeyup(int key, int x1, int y1)
{
	switch (key) {

		case GLUT_KEY_UP:
			character.object.movement.speed = 0;
			character.object.movement.key[0] = 0;
			break;
		case GLUT_KEY_RIGHT:
			character.object.movement.speed = 0;
			character.object.movement.key[1] = 0;
			break;
		case GLUT_KEY_DOWN:
			character.object.movement.speed = 0;
			character.object.movement.key[2] = 0;
			break;
		case GLUT_KEY_LEFT:
			character.object.movement.speed = 0;
			character.object.movement.key[3] = 0;
			break;
		default:
			break;
	}
	
}

//keyboard function---------------------------------------------------------------------------------------------------------------
void keyboard(unsigned char key, int x1, int y1)
{
	switch (key) {
		case 27://escape key
			exit(0);//exit game
			break;
		case 'j'://jump?
	//		player.ay = 1;
			break;
		default:
			break;
	}
}

//main function------------------------------------------------------------------------------------------------------------------------
int main(int argc,char *argv[])
{
	glutInit(&argc,argv);//initialise glut
	glutInitDisplayMode(GLUT_DEPTH|GLUT_DOUBLE|GLUT_RGBA);
	glutInitWindowSize(320,240);
	glutInitWindowPosition(320,240);
	glutCreateWindow("Randomware");
	score.score = 0;
	init();
	glutSpecialFunc(skeydown);//key pressed
	glutSpecialUpFunc(skeyup);//key released
	
	glutDisplayFunc(display);
	glutIdleFunc(update);
	
	glutMainLoop();

	return 0;

}
